15-APR-2018
Version 0.1

Prerequisites:
* Windows 10
* .NET Framework 4+ (preinstalled in Windows 10)
* Microsoft Flight Simulator X (any edition)
* External controller such as yoke, joystick or pedals

1) click2fs

Simple UI tool that allows to select controller and see events when buttons pressed/released or axis used. It’s helpful to find out names of controllers and buttons that can be subsequently used in configuration file for joy2fs tool. Those names are not matching what FSX shows.

2) joy2fs

Tool that is actually sending key combinations to FSX when button on external control pressed. Mapping between buttons and key combinations is specified in JSON configuration file. Its format pretty simple:
{ "DeviceMap": { 
 "PartOfDeviceName1": { "Button0":"KeyCombination0",..,"ButtonX":"KeyCombinationX" }, 
"PartOfDeviceName2": {  "Button0":"KeyCombination0",..,"ButtonX":"KeyCombinationX" } 
} }
 
Example:
{
   "DeviceMap":{
      "Yoke":{
         "Buttons1":"SHIFT+CTRL+Z",
         "Buttons17":"SHIFT+CTRL+G",
         "Buttons18":"CTRL+OEM_PERIOD",
         "Buttons19":"SHIFT+CTRL+R"
      }
   }
}
In this example Yoke is unique part of controller’s name and ButtonsX respectively names of buttons. Both can be found using click2fs tool. SHIFT+CTRL+OEM_PERIOD should be pretty obvious besides the OEM_ part which is coming from Windows virtual keys identifiers described at https://msdn.microsoft.com/en-us/library/windows/desktop/dd375731(v=vs.85).aspx 
Ultimately following values can be used in key combinations:
* Functional keys: F1 to F24
* Alphanumeric: A to Z and 0 to 9
* OEM: OEM_1, OEM_2, OEM_3, OEM_4, OEM_5, OEM_6, OEM_7, OEM_8, OEM_102, OEM_CLEAR, OEM_COMMA, OEM_MINUS, OEM_PERIOD,  OEM_PLUS
* Numpad: NUMPAD0 to NUMPAD9 and ADD, MULTIPLY, DIVIDE, SUBTRACT 
* Cursor: LEFT, RIGHT, UP, DOWN, PAGE_UP, PAGE_DOWN, HOME, END, BACKSPACE
* Media: MEDIA_PREV_TRACK, MEDIA_NEXT_TRACK, MEDIA_PLAY_PAUSE, MEDIA_STOP, VOLUME_UP, VOLUME_DOWN, VOLUME_MUTE
* Other: ALT, CTRL, SHIFT, TAB, SPACE_BAR, ENTER, CAPS_LOCK, NUM_LOCK, ESC, INSERT, DELETE

Please make sure buttons of controller used in this tool are not assigned to any action in FSX. In case joy2s tool can’t find FSX window key combinations will be sent to any foreground window. As a side effect it opens up some new use cases. For example you could use buttons on joystick to change audio volume up and down.

I am planning to add support for P3D in near future.

NOTE1: It’s important to run this tool as Administrator. Otherwise key combinations won’t be received by FSX.
NOTE2: When tool started external controllers should be already connected to your PC and recognized by Windows. Best way to check it is open Device Manager and find controllers in tree of devices.

http://www.realadsb.com/joy2fs.html